#include <stdio.h>
#include <stdlib.h>


FILE *fptr;

/* returns the next instruction word in the trace.              */
/* If the end of file is reached or if an error occurs, it will */
/* return 0                                                     */
unsigned int get_next_instruction() {
    unsigned int instr;
    if(fscanf(fptr, "%x", &instr) != 1)
        return 0;
    else return instr;
}

/* main trace simulator function */
void simulator(int numcycles) {
    /* WRITE ME */
    /* you can use get_next_instruction() above */


    /* This is sample code only, it shows you how to use
       get_next_instruction.  You don't have to use it in you code */
    int instr;
    int cycles;

    while( (instr = get_next_instruction()) != 0 && cycles < numcycles ) {
      printf("Processing instruction: %08x\n", instr);
    }

    printf("Done processing\n");
    /* end sample code */
}


int main(int argc, char **argv) {
    int numcycles;

    if(argc < 3) {
        printf("Usage: %s <tracefile> <number of cycles to simulate>\n", argv[0]);
        printf("Example: %s trace.txt 25\n", argv[0]);
        exit(0);
    }
    
    if(NULL == (fptr = fopen(argv[1], "r"))) {
        printf("Error: cannot open input trace file\n");
        exit(0);
    }

    numcycles = atoi(argv[2]);
    if(numcycles <= 0) {
        printf("Error: number of cycles to simulate must be positive\n");
        exit(0);
    }

    simulator(numcycles);
    fclose(fptr);
    return 0;
}
